#!/bin/csh -f
#
#usage () { echo Usage: horizontal [Input file name] [Output ps file name] [Vp or Vs] [West] [East] [South] [North] [lon-int] [lat-int] [Size]}
#

set INFILE = $1
set OUTPUT = $2
set PS = $3
set WEST = $4
set EAST = $5
set SOUTH = $6
set NORTH = $7
set OINT = $8
set AINT = $9
set SIZE = $10

if ($PS == 1) then
    set VK = 'Vp'
    set FCPT = vp.cpt
endif
if ($PS == 2) then
    set VK = 'Vs'
    set FCPT = vs.cpt
endif

if (-e $OUTPUT) then
    rm -f $OUTPUT
endif

gmtset BASEMAP_TYPE plain

#pstext -R0/29/0/29 -Jx1 -Ba1g1NSEW -K -X1 -Y1 -P << END > $OUTPUT
pstext -R0/29/0/29 -Jx1 -K -X1 -Y1 -P << END > $OUTPUT
9.2  2.2 20 0.0 5 7 $VK
15.0  1.2 20 0.0 5  1 km/s
END

psmask $INFILE -I$OINT/$AINT -JM$SIZE -V -R$WEST/$EAST/$SOUTH/$NORTH -K -O -Y4.0 -X1.5 >> $OUTPUT
surface $INFILE -Gvel.grd -I$OINT/$AINT -R -T0.75
grdimage vel.grd -C$FCPT -R -JM -K -V -O -U >> $OUTPUT
#grdcontour vel.grd -JM -O -K -R -A1f5 -Wa1/0/0/255 -Wc1/0/0/255 -C0.2 >>  $OUTPUT
psmask -C -K -O >> $OUTPUT

psxy hinet.xy -JM -R -Sx0.05 -W3/0/0/0 -O -K >> $OUTPUT
pscoast -R -JM -Ba2f0.5/a1f0.5WsNe -K -O -W2 -Dh -V >> $OUTPUT

xyz2grd pert_sample.dat -Gpert_sample.grd -I0.01/1 -R-30/30/1/2 -Ddegree/degree/percent/1/0/hida/pert_sample.xyz -N0 -V
if ($PS == 1) then
grdimage pert_sample.grd -C$FCPT -B1/5Swne -R5/9/1/2 -JX4.5/1 -Y-2.0 -X8.25 -V -O >> $OUTPUT
endif
if ($PS == 2) then
grdimage pert_sample.grd -C$FCPT -B1/5Swne -R2/5/1/2 -JX4.5/1 -Y-2.0 -X8.25 -V -O >> $OUTPUT
endif

\rm -f vel.grd

#gs $OUTPUT
