#!/bin/csh -f
#
#usage () { echo Usage: THK.csh INFILE PS LAT[39.54]; }
#

set INFILE = $1
set OUTPUT = $2
set PS = $3
set LEFT  = $4
set RIGHT = $5
set DOWN  = $6
set UP    = $7
set HINT = $8
set VINT = $9
set SIZEX = $10
set SIZEY = $11

if ($PS == 1) then
    set VK = 'Vp'
    set FCPT = vp.cpt
endif
if ($PS == 2) then
    set VK = 'Vs'
    set FCPT = vs.cpt
endif

echo $OUTPUT

if (-e $OUTPUT) then
    rm -f $OUTPUT
endif

#pstext -R0/29/0/29 -Jx1 -Ba1g1NSEW -K -X1 -Y1 << END > $OUTPUT
pstext -R0/29/0/29 -Jx1 -K -X1 -Y1 << END > $OUTPUT
11.5  1.0 20 0.0 5  7 $VK
17.5  0.5 20 0.0 5  6 km/s
END

psmask $INFILE -I$HINT/$VINT -JX$SIZEX/$SIZEY -K -V -O -Y3.0 -X2.5 -R$LEFT/$RIGHT/$UP/$DOWN -Ba1f1/a50f10WsNe >> $OUTPUT
xyz2grd $INFILE -Gvel.grd -I0.01/1 -R -V
grdimage vel.grd -C$FCPT -JX -K -V -O >> $OUTPUT
grdcontour vel.grd -R -JX -Wa2/0/0/255 -Wc1/0/0/255 -C0.5 -A0.5f5 -K -O >> $OUTPUT
psmask -C -K -O >> $OUTPUT

if ($PS == 1) then
grdimage pert_sample.grd -C$FCPT -B1/5Swne -R5/9/1/2 -JX4.5/1 -Y-2.0 -X9.25 -V -O >> $OUTPUT
endif
if ($PS == 2) then
grdimage pert_sample.grd -C$FCPT -B1/5Swne -R2/5/1/2 -JX4.5/1 -Y-2.0 -X9.25 -V -O >> $OUTPUT
endif

\rm -f vel.grd

#gs $OUTPUT
