/* This Programme is used for 
   to calculate velocity and reliability at any point
   gcc interpolate.c
 */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include <ctype.h>
#include <dirent.h>

#define latint 0.1000
#define lonint 0.1000
#define numlon 301
#define numlat 281
#define numdep 32
#define lonw   120.000
#define lats   20.000

void usage() {
  fputs("Usage : interpolate [param] [output file]\n",
	stderr);
}

main(argc, argv)
     int  argc;
     char **argv;
{
  static int i, j, k,numdata,ndata, i0,i1,j0,j1,k0,k1;
  static float lon[310],lat[290],dep[50],vp[310][290][50],vs[310][290][50],
    rp[310][290][50],rs[310][290][50],X,Y,Z,x0,x1,y0,y1,z0,z1,dx,dy,dz,
    lon1,lat1,dep1,vp000,vp100,vp010,vp110,vp001,vp101,vp011,vp111,
    vs000,vs100,vs010,vs110,vs001,vs101,vs011,vs111,
    rp000,rp100,rp010,rp110,rp001,rp101,rp011,rp111,
    rs000,rs100,rs010,rs110,rs001,rs101,rs011,rs111,
    vp0,vs0,rp0,rs0;
  static char infile[256], outfile[256], buffer[256];
  FILE *lstfp,*infp,*outfp, *datafp;

  if(argc != 3){
    usage();
    exit(1);
  }

  sprintf(infile, "%s", argv[1]);
  sprintf(outfile, "%s", argv[2]);

  if((lstfp = fopen("LON.lst", "r")) == NULL) {
    fprintf(stderr, "LON.lst not found!!\n");
    exit(1);
  }

  for(i=0;i<numlon;i++){
    fgets(buffer, 255, lstfp);
    sscanf(buffer, "%f", &lon[i]);
  }
  close(lstfp);

  if((lstfp = fopen("LAT.lst", "r")) == NULL) {
    fprintf(stderr, "LAT.lst not found!!\n");
    exit(1);
  }

  for(j=0;j<numlat;j++){
    fgets(buffer, 255, lstfp);
    sscanf(buffer, "%f", &lat[j]);
  }
  close(lstfp);

  if((lstfp = fopen("DEP.lst", "r")) == NULL) {
    fprintf(stderr, "DEP.lst not found!!\n");
    exit(1);
  }

  for(k=0;k<numdep;k++){
    fgets(buffer, 255, lstfp);
    sscanf(buffer, "%f", &dep[k]);
  }
  close(lstfp);

  if((datafp = fopen("VEL.dat", "r")) == NULL) {
    fprintf(stderr, "VEL.dat not found!!\n");
    exit(1);
  }

  for(k=0;k<numdep;k++){
    for(i=0;i<numlon;i++){
      for(j=0;j<numlat;j++){
	fgets(buffer, 255, datafp);
	sscanf(buffer, "%f%f%f%f%f%f%f",
	       &lon1,&lat1,&dep1,&vp[i][j][k],&vs[i][j][k],&rp[i][j][k],&rs[i][j][k]);
	if(lon1!=lon[i]||lat1!=lat[j]||dep1!=dep[k]) {
	  fprintf(stderr, "%d %d %d %f %f %f %f %f %f\n",
		  i, j, k, lon1,lat1,dep1,lon[i],lat[j],dep[k]);
	  fprintf(stderr, "INPUT FILE ERROR\n");
	  return;
	}
      }
    }
  }
  close(datafp);

  if((infp = fopen(infile, "r")) == NULL) {
    fprintf(stderr, "%s not found!!\n", infile);
    exit(1);
  }

  if((outfp = fopen(outfile, "w")) == NULL) {
    fprintf(stderr, "%s not found!!\n", outfile);
    exit(1);
  }

  fgets(buffer, 255, infp);
  sscanf(buffer, "%d", &numdata);

  for(ndata=0; ndata<numdata; ndata++){
    fgets(buffer, 255, infp);
    sscanf(buffer, "%f%f%f", &X,&Y,&Z);
    i0=(int)((X-lonw)/lonint);
    i1=i0+1;
    j0=(int)((Y-lats)/latint);
    j1=j0+1;
    for(k=0;k<numdep;k++){
      if(dep[k]>Z) {
	k0=k-1; k1=k;
	break;
      }
    }

    vp000=1./vp[i0][j0][k0]; vs000=1./vs[i0][j0][k0]; rp000=rp[i0][j0][k0]; rs000=rs[i0][j0][k0];
    vp100=1./vp[i1][j0][k0]; vs100=1./vs[i1][j0][k0]; rp100=rp[i1][j0][k0]; rs100=rs[i1][j0][k0];
    vp010=1./vp[i0][j1][k0]; vs010=1./vs[i0][j1][k0]; rp010=rp[i0][j1][k0]; rs010=rs[i0][j1][k0];
    vp110=1./vp[i1][j1][k0]; vs110=1./vs[i1][j1][k0]; rp110=rp[i1][j1][k0]; rs110=rs[i1][j1][k0];
    vp001=1./vp[i0][j0][k1]; vs001=1./vs[i0][j0][k1]; rp001=rp[i0][j0][k1]; rs001=rs[i0][j0][k1];
    vp101=1./vp[i1][j0][k1]; vs101=1./vs[i1][j0][k1]; rp101=rp[i1][j0][k1]; rs101=rs[i1][j0][k1];
    vp011=1./vp[i0][j1][k1]; vs011=1./vs[i0][j1][k1]; rp011=rp[i0][j1][k1]; rs011=rs[i0][j1][k1];
    vp111=1./vp[i1][j1][k1]; vs111=1./vs[i1][j1][k1]; rp111=rp[i1][j1][k1]; rs111=rs[i1][j1][k1];
    x0=lon[i0]; x1=lon[i1]; dx=x1-x0;
    y0=lat[j0]; y1=lat[j1]; dy=y1-y0;
    z0=dep[k0]; z1=dep[k1]; dz=z1-z0;

    vp0=1./((vp000*(x1-X)*(y1-Y)*(z1-Z)+vp010*(x1-X)*(Y-y0)*(z1-Z)+
	 vp100*(X-x0)*(y1-Y)*(z1-Z)+vp110*(X-x0)*(Y-y0)*(z1-Z)+
	 vp001*(x1-X)*(y1-Y)*(Z-z0)+vp011*(x1-X)*(Y-y0)*(Z-z0)+
	 vp101*(X-x0)*(y1-Y)*(Z-z0)+vp111*(X-x0)*(Y-y0)*(Z-z0))
      /dx/dy/dz);
    vs0=1./((vs000*(x1-X)*(y1-Y)*(z1-Z)+vs010*(x1-X)*(Y-y0)*(z1-Z)+
	 vs100*(X-x0)*(y1-Y)*(z1-Z)+vs110*(X-x0)*(Y-y0)*(z1-Z)+
	 vs001*(x1-X)*(y1-Y)*(Z-z0)+vs011*(x1-X)*(Y-y0)*(Z-z0)+
	 vs101*(X-x0)*(y1-Y)*(Z-z0)+vs111*(X-x0)*(Y-y0)*(Z-z0))
      /dx/dy/dz);
    rp0=(rp000*(x1-X)*(y1-Y)*(z1-Z)+rp010*(x1-X)*(Y-y0)*(z1-Z)+
	 rp100*(X-x0)*(y1-Y)*(z1-Z)+rp110*(X-x0)*(Y-y0)*(z1-Z)+
	 rp001*(x1-X)*(y1-Y)*(Z-z0)+rp011*(x1-X)*(Y-y0)*(Z-z0)+
	 rp101*(X-x0)*(y1-Y)*(Z-z0)+rp111*(X-x0)*(Y-y0)*(Z-z0))
      /dx/dy/dz;
    rs0=(rs000*(x1-X)*(y1-Y)*(z1-Z)+rs010*(x1-X)*(Y-y0)*(z1-Z)+
	 rs100*(X-x0)*(y1-Y)*(z1-Z)+rs110*(X-x0)*(Y-y0)*(z1-Z)+
	 rs001*(x1-X)*(y1-Y)*(Z-z0)+rs011*(x1-X)*(Y-y0)*(Z-z0)+
	 rs101*(X-x0)*(y1-Y)*(Z-z0)+rs111*(X-x0)*(Y-y0)*(Z-z0))
      /dx/dy/dz;
    if(rp0>0.8001||rp0<0.0) vp0=0.1;
    if(rs0>0.8001||rs0<0.0) vs0=0.1;
    fprintf(outfp,"%7.3f%7.3f%7.2f%7.3f%6.3f%7.3f%7.3f\n",
	    X,Y,Z,vp0,vs0,rp0,rs0);
  }
  fclose(infp);
  fclose(outfp);
  return;
}
